#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

static char* echoing_fgets(char* buf, size_t size, FILE* stream)
{
    char* s = buf;
    memset(buf, 0, size);
    size_t oldsize = size;
    while (size)
    {
        int c = fgetc(stream);
        if (c == EOF)
        {
            if (ferror(stream)) return NULL;
            if (feof(stream))
            {
                if (s != buf) return s;
                else
                    return NULL;
            };
        }
        if ((char)c == '\b')
        {
            if (size != oldsize)
            {
                buf--;
                size++;
                putchar('\b');
            }
        }
        else
        {
            size--;
            *buf = (char)c;
            buf++;
            putchar((char)c);
            if ((char)c == '\n') return s;
        }
        *buf = 0;
    }
    return s;
}

int main(int argc, char** argv)
{
    if (argc == 1)
    {
        fprintf(stderr, "Usage: %s [directory]\n", argv[0]);
        return 1;
    }

    int fd = open(argv[1], O_WRONLY | O_CREAT | O_APPEND, 0755);

    if (fd < 0)
    {
        perror("open");
        return 1;
    }

    FILE* fp = fdopen(fd, "a");

    char buf[BUFSIZ];
    echoing_fgets(buf, BUFSIZ, stdin);

    fputs(buf, fp);
    if (ferror(fp))
    {
        perror("fputs");
        return 1;
    }

    fclose(fp);
}